--
-- AIUpdate
-- Speichert den Kurs der Helfer
--
-- @author  Geri-G
-- @date  08/11/10

local origAICombineGetSaveAttributesAndNodes = AICombine.getSaveAttributesAndNodes;
local origAICombineLoadFromAttributesAndNodes = AICombine.loadFromAttributesAndNodes;
local oldload =  AICombine.load;
local oldDraw =  AICombine.draw;
local oldStartAI =  AICombine.startAIThreshing;
local oldReadStream =  AICombine.readStream;
local oldWriteStream =  AICombine.writeStream;



AICombine.load = function(self, xmlFile)
	oldload(self, xmlFile);
	self.oldCourseDelete = false;
	self.reverseCourse = false;
	self.InputTimer = 0;
	self.ResetAi = AICombine.ResetAi;
end;
AICombine.loadFromAttributesAndNodes = function(self, xmlFile, key, resetVehicles)
    if origAICombineLoadFromAttributesAndNodes ~= nil then
        local r = origAICombineLoadFromAttributesAndNodes(self, xmlFile, key, resetVehicles);
        if r ~= BaseMission.VEHICLE_LOAD_OK then
            return r;
        end;
    end;

	local x,y,z = Utils.getVectorFromString(getXMLString(xmlFile, key.."#lastDirection"));
	if x and z then
		self.aiThreshingDirectionX = x
		self.aiThreshingDirectionZ = z
	else
		self:ResetAi(true);
	end
	
    return BaseMission.VEHICLE_LOAD_OK;
end;
AICombine.getSaveAttributesAndNodes = function(self, nodeIdent)
    local attributes, nodes;
    if origAICombineGetSaveAttributesAndNodes ~= nil then
        attributes, nodes = origAICombineGetSaveAttributesAndNodes(self, nodeIdent);
    end;
	
    local modStr = ""	
	if self.aiThreshingDirectionX and self.aiThreshingDirectionZ then
		modStr = 'lastDirection="'..self.aiThreshingDirectionX..' 0 '..self.aiThreshingDirectionZ..'" ';
	end
	
    if attributes == nil then
        attributes = modStr;
    else
        attributes = attributes .. " "..modStr;
    end;
    return attributes, nodes;
end;
AICombine.readStream = function(self, streamId, connection)
	oldReadStream(self, streamId, connection);
	self.oldCourseDelete = streamReadBool(streamId);
	self.reverseCourse = streamReadBool(streamId);
end;
AICombine.writeStream = function(self, streamId, connection)
	oldWriteStream(self, streamId, connection);
	streamWriteBool(streamId, self.oldCourseDelete);
	streamWriteBool(streamId, self.reverseCourse);
end;
AICombine.startAIThreshing = function(self, noEventSend)
	local dirX, dirZ ;
	if self.isServer then
		dirX, dirZ = self.aiThreshingDirectionX, self.aiThreshingDirectionZ;
	end;
	oldStartAI(self, noEventSend);
	if self.isServer then
		if not self.oldCourseDelete and dirZ ~= nil then
			self.aiThreshingDirectionX, self.aiThreshingDirectionZ = dirX, dirZ;
			if self.reverseCourse then
				self.aiThreshingDirectionX, self.aiThreshingDirectionZ = -dirX, -dirZ;
				self:ResetAi(false,false);	
			end;
		elseif self.oldCourseDelete then
			self:ResetAi(false,false);			
		end;	
	end;	
end;
AICombine.draw = function(self)
	oldDraw(self);
	if not self.oldCourseDelete and not self.isAIThreshing and self:canStartAIThreshing() then
		g_currentMission:addHelpButtonText(g_i18n:getText("AI_COURSE"), InputBinding.AI_COURSE)
		if InputBinding.isPressed(InputBinding.AI_COURSE) then
			if self.InputTimer <=0 then
				self.InputTimer = self.time+1500;
			end;
		else
			if self.InputTimer > 0 then			
				if self.InputTimer >= self.time then					
					self:ResetAi(false,true,nil);
				elseif self.InputTimer <= self.time then
					self:ResetAi(true,false,nil);
				end;
			end;
		end
		--g_currentMission:addExtraPrintText(string.format("time: %0.3f InputTimer: %0.3f ",self.time,self.InputTimer));
	end;


end;
function AICombine:ResetAi(reset,reverse,noEventSend)
	AiResetEvent.sendEvent(self,noEventSend,reset,reverse);
	self.oldCourseDelete = reset;
	self.reverseCourse = reverse;
	self.InputTimer = 0;
end;


local origAITractorGetSaveAttributesAndNodes = AITractor.getSaveAttributesAndNodes;
local origAITractorLoadFromAttributesAndNodes = AITractor.loadFromAttributesAndNodes;
local oldload =  AITractor.load;
local oldDraw =  AITractor.draw;
local oldStartAI =  AITractor.startAITractor;
local oldReadStream =  AITractor.readStream;
local oldWriteStream =  AITractor.writeStream;


AITractor.load = function(self, xmlFile)
	oldload(self, xmlFile);
	self.oldCourseDelete = false;
	self.reverseCourse = false;	
	self.InputTimer = 0;
	self.ResetAi = AITractor.ResetAi;
end;
AITractor.loadFromAttributesAndNodes = function(self, xmlFile, key, resetVehicles)
    if origAITractorLoadFromAttributesAndNodes ~= nil then
        local r = origAITractorLoadFromAttributesAndNodes(self, xmlFile, key, resetVehicles);
        if r ~= BaseMission.VEHICLE_LOAD_OK then
            return r;
        end;
    end;

	local x,y,z = Utils.getVectorFromString(getXMLString(xmlFile, key.."#lastDirection"));
	if x and z then
		self.aiTractorDirectionX = x
		self.aiTractorDirectionZ = z
	else
		self:ResetAi(true);
	end
	
    return BaseMission.VEHICLE_LOAD_OK;
end;
AITractor.getSaveAttributesAndNodes = function(self, nodeIdent)
    local attributes, nodes= "","";
    if origAITractorGetSaveAttributesAndNodes ~= nil then
        attributes, nodes = origAITractorGetSaveAttributesAndNodes(self, nodeIdent);
    end;
	
    local modStr = ""	
	if self.aiTractorDirectionX and self.aiTractorDirectionZ then
		modStr = 'lastDirection="'..self.aiTractorDirectionX..' 0 '..self.aiTractorDirectionZ..'" ';
	end
	local ishere = string.find(attributes, 'lastDirection');
	if ishere == nil then
		if attributes == nil then
			attributes = modStr;
		else
			attributes = attributes .. " "..modStr;
		end;
	end;
    return attributes, nodes;
end;
AITractor.readStream = function(self, streamId, connection)
	oldReadStream(self, streamId, connection);
	self.oldCourseDelete = streamReadBool(streamId);
	self.reverseCourse = streamReadBool(streamId);
end;
AITractor.writeStream = function(self, streamId, connection)
	oldWriteStream(self, streamId, connection);
	streamWriteBool(streamId, self.oldCourseDelete);
	streamWriteBool(streamId, self.reverseCourse);
end;
AITractor.startAITractor = function(self, noEventSend)
	local dirX, dirZ ;
	if self.isServer then
		dirX, dirZ = self.aiTractorDirectionX, self.aiTractorDirectionZ;
	end;
	oldStartAI(self, noEventSend);
	if self.isServer then
		if not self.oldCourseDelete and dirZ ~= nil then
			self.aiTractorDirectionX, self.aiTractorDirectionZ = dirX, dirZ;
			if self.reverseCourse then
				self.aiTractorDirectionX, self.aiTractorDirectionZ = -dirX, -dirZ;
				self:ResetAi(false,false);	
			end;
		elseif self.oldCourseDelete then
			self:ResetAi(false,false);			
		end;
	end;
end;
AITractor.draw = function(self)
	oldDraw(self);
	if not self.oldCourseDelete and not self.isAITractorActivated and self:canStartAITractor() then
		g_currentMission:addHelpButtonText(g_i18n:getText("AI_COURSE"), InputBinding.AI_COURSE)
		if InputBinding.isPressed(InputBinding.AI_COURSE) then
			if self.InputTimer <=0 then
				self.InputTimer = self.time+1500;
			end;
		else
			if self.InputTimer > 0 then			
				if self.InputTimer >= self.time then					
					self:ResetAi(false,true,nil);
				elseif self.InputTimer <= self.time then
					self:ResetAi(true,false,nil);
				end;
			end;
		end
		--g_currentMission:addExtraPrintText(string.format("time: %0.3f InputTimer: %0.3f ",self.time,self.InputTimer));
	end;

end;
function AITractor:ResetAi(reset,reverse,noEventSend)
	AiResetEvent.sendEvent(self,noEventSend,reset,reverse);
	self.oldCourseDelete = reset;
	self.reverseCourse = reverse;
	self.InputTimer = 0;
end;