AiResetEvent = {};
AiResetEvent_mt = Class(AiResetEvent, Event);

InitEventClass(AiResetEvent, "AiResetEvent");

function AiResetEvent:emptyNew()
    local self = Event:new(AiResetEvent_mt);
    self.className="AiResetEvent";
    return self;
end;

function AiResetEvent:new(object,reset,reverse)
    local self = AiResetEvent:emptyNew()
    self.object = object;
    self.reset = reset;
    self.reverse = reverse;
    return self;
end;

function AiResetEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);	
    self.reset = streamReadBool(streamId);
    self.reverse = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function AiResetEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.reset);
    streamWriteBool(streamId, self.reverse);
end;

function AiResetEvent:run(connection)   
	self.object:ResetAi(self.reset,self.reverse,true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(AiResetEvent:new(self.object,self.reset,self.reverse), nil, connection, self.object);
    end;
end;

function AiResetEvent.sendEvent(vehicle, noEventSend, reset,reverse)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(AiResetEvent:new(vehicle,reset,reverse), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(AiResetEvent:new(vehicle,reset,reverse));
		end;
	end;

end;